Imports System.IO.Compression

Public Class Form1

#Region " Sent data "
    Private Sub but_sent_str_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_sent_str_str.Click
        Dim InputString As String = ""
        InputString += "<sent>"
        InputString += "<settings>"
        InputString += "<id>0</id>" '(required)
        InputString += "<max_recs>0</max_recs>" '(optional) records returned, min : 0 -> max : 100
        InputString += "<cols_returned>Numto,CustomerID</cols_returned>" '(optional) SentID,EventID,SMSType,NumTo,Data,Flash,CustomerID,Status,StatusDate
        InputString += "<date_format>dd/MMM/yyyy</date_format>" '(optional) dd = day. MM = month. MMM = monthname (feb). yyyy = year. HH = hour. mm = minute. ss = second
        InputString += "</settings>"
        InputString += "</sent>"

        txt_sent_results.Text = "Input:" & vbCrLf
        txt_sent_results.AppendText(InputString & vbCrLf & vbCrLf)

        txt_sent_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_sent_results.AppendText(MyAPI.Sent_STR_STR(txt_username.Text, txt_password.Text, InputString))
        End Using
    End Sub

    Private Sub but_sent_str_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_sent_str_ds.Click
        Dim InputString As String = ""
        InputString += "<sent>"
        InputString += "<settings>"
        InputString += "<id>0</id>" '(required)
        InputString += "<max_recs>0</max_recs>" '(optional) records returned, min : 0 -> max : 100
        InputString += "<cols_returned>Numto,CustomerID,Status,StatusDate</cols_returned>" '(optional) SentID,EventID,SMSType,NumTo,Data,Flash,CustomerID,Status,StatusDate
        InputString += "<date_format>dd/MMM/yyyy</date_format>" '(optional) dd = day. MM = month. MMM = monthname (feb). yyyy = year. HH = hour. mm = minute. ss = second
        InputString += "</settings>"
        InputString += "</sent>"

        txt_sent_results.Text = "Input:" & vbCrLf
        txt_sent_results.AppendText(InputString & vbCrLf & vbCrLf)

        txt_sent_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_sent_results.AppendText(MyAPI.Sent_STR_DS(txt_username.Text, txt_password.Text, InputString).GetXml)
        End Using
    End Sub

    Private Sub but_sent_ds_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_sent_ds_ds.Click
        Dim DS As New DataSet("sent")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("id") 'Number
        DT.Columns.Add("max_recs") 'Number (default = 100)
        DT.Columns.Add("cols_returned") 'sentid,eventid,smstype,numto,data,flash,customerid,status,statusdate
        DT.Columns.Add("date_format") 'blah

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("id") = "0"
        MainDR.Item("max_recs") = "0"
        MainDR.Item("cols_returned") = "sentid,eventid,smstype,numto,data,flash,customerid,status,statusdate"
        MainDR.Item("date_format") = "yyyyMMddHHmmss"
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_sent_results.Text = "Input:" & vbCrLf
        txt_sent_results.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_sent_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_sent_results.AppendText(MyAPI.Sent_DS_DS(txt_username.Text, txt_password.Text, DS).GetXml)
        End Using
    End Sub

    Private Sub but_sent_ds_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_sent_ds_str.Click
        Dim DS As New DataSet("sent")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("id") 'Number
        DT.Columns.Add("max_recs") 'Number (default = 100)
        DT.Columns.Add("cols_returned") 'blah
        DT.Columns.Add("date_format") 'blah

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("id") = "0"
        MainDR.Item("max_recs") = "0"
        MainDR.Item("cols_returned") = "CustomerID,Status,Statusdate"
        MainDR.Item("date_format") = "yyyyMMddHHmmss"
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_sent_results.Text = "Input:" & vbCrLf
        txt_sent_results.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_sent_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_sent_results.AppendText(MyAPI.Sent_DS_STR(txt_username.Text, txt_password.Text, DS))
        End Using
    End Sub
#End Region

#Region " Reply Data "
    Private Sub but_reply_str_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_reply_str_str.Click
        Dim InputString As String = ""
        InputString += "<reply>"
        InputString += "<settings>"
        InputString += "<id>0</id>" '(required)
        InputString += "<max_recs>0</max_recs>" '(optional) records returned, min : 0 -> max : 100
        InputString += "<cols_returned>numfrom,received</cols_returned>" '(optional) eventid,numfrom,receiveddata,received,sentid,sentdata,sentdatetime,sentcustomerid
        InputString += "<date_format>dd/MMM/yyyy</date_format>" '(optional) dd = day. MM = month. MMM = monthname (feb). yyyy = year. HH = hour. mm = minute. ss = second
        InputString += "</settings>"
        InputString += "</reply>"

        txt_reply_results.Text = "Input:" & vbCrLf
        txt_reply_results.AppendText(InputString & vbCrLf & vbCrLf)

        txt_reply_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_reply_results.AppendText(MyAPI.Reply_STR_STR(txt_username.Text, txt_password.Text, InputString))
        End Using
    End Sub

    Private Sub but_reply_str_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_reply_str_ds.Click
        Dim InputString As String = ""
        InputString += "<reply>"
        InputString += "<settings>"
        InputString += "<id>0</id>" '(required)
        InputString += "<max_recs>0</max_recs>" '(optional) records returned, min : 0 -> max : 100
        InputString += "<cols_returned>numfrom,received</cols_returned>" '(optional) eventid,numfrom,receiveddata,received,sentid,sentdata,sentdatetime,sentcustomerid
        InputString += "<date_format>dd/MMM/yyyy</date_format>" '(optional) dd = day. MM = month. MMM = monthname (feb). yyyy = year. HH = hour. mm = minute. ss = second
        InputString += "</settings>"
        InputString += "</reply>"

        txt_reply_results.Text = "Input:" & vbCrLf
        txt_reply_results.AppendText(InputString & vbCrLf & vbCrLf)

        txt_reply_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_reply_results.AppendText(MyAPI.Reply_STR_DS(txt_username.Text, txt_password.Text, InputString).GetXml)
        End Using
    End Sub

    Private Sub but_reply_ds_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_reply_ds_ds.Click
        Dim DS As New DataSet("reply")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("id") 'REQUIRED. Maximum REPLYID from previous call
        DT.Columns.Add("max_recs") 'OPTIONAL. Number (default = 100)
        DT.Columns.Add("cols_returned") 'OPTIONAL. Seperte col name with comma, this allows you to strip the returned data (default = replyid)
        DT.Columns.Add("date_format") 'OPTIONAL. (default = dd/MMM/yyyy HH:mm:ss)

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("id") = "0"
        MainDR.Item("max_recs") = "0"
        MainDR.Item("cols_returned") = "numfrom,receiveddata,received,sentcustomerid" 'eventid,numfrom,receiveddata,received,sentid,sentdata,sentdatetime,sentcustomerid
        MainDR.Item("date_format") = "yyyyMMddHHmmss"
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_reply_results.Text = "Input:" & vbCrLf
        txt_reply_results.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_reply_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_reply_results.AppendText(MyAPI.Reply_DS_DS(txt_username.Text, txt_password.Text, DS).GetXml)
        End Using
    End Sub

    Private Sub but_reply_ds_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_reply_ds_str.Click
        Dim DS As New DataSet("reply")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("id") 'REQUIRED. Maximum REPLYID from previous call
        DT.Columns.Add("max_recs") 'OPTIONAL. Number (default = 100)
        DT.Columns.Add("cols_returned") 'OPTIONAL. Seperte col name with comma, this allows you to strip the returned data (default = replyid)
        DT.Columns.Add("date_format") 'OPTIONAL. (default = dd/MMM/yyyy HH:mm:ss)

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("id") = "0"
        MainDR.Item("max_recs") = "0"
        MainDR.Item("cols_returned") = "numfrom,received" 'EventID,NumFrom,ReceivedData,Received,SentID,SentData,SentDateTime,SentCustomerID
        MainDR.Item("date_format") = "yyyyMMddHHmmss"
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_reply_results.Text = "Input:" & vbCrLf
        txt_reply_results.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_reply_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_reply_results.AppendText(MyAPI.Reply_DS_STR(txt_username.Text, txt_password.Text, DS))
        End Using
    End Sub
#End Region

#Region " Send Data "
    Private Sub but_send_ds_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_send_ds_ds.Click
        If txt_number.Text.Equals("") Then
            MsgBox("Please enter a number")
            Exit Sub
        End If

        Dim DS As New DataSet("senddata")

        ' --------------------------------- Settings --------------------------------- 
        Dim DT_Settings As New DataTable("settings")
        DT_Settings.Columns.Add("live") 'OPTIONAL - True/False (default - true)
        DT_Settings.Columns.Add("return_credits") 'OPTIONAL - True/False
        DT_Settings.Columns.Add("return_msgs_success_count") 'OPTIONAL - True/False (default - false)
        DT_Settings.Columns.Add("return_msgs_failed_count") 'OPTIONAL - True/False (default - false)
        DT_Settings.Columns.Add("return_entries_success_status") 'OPTIONAL - True/False (default - false)
        DT_Settings.Columns.Add("return_entries_failed_status") 'OPTIONAL - True/False (default - false)
        DT_Settings.Columns.Add("default_senderid") 'OPTIONAL - 11 Char alphanumeric or 15 char numeric (default - Repliable)
        DT_Settings.Columns.Add("default_date") 'REQUIRED - dd/MMM/yyyy
        DT_Settings.Columns.Add("default_time") 'REQUIRED - HH:mm
        DT_Settings.Columns.Add("default_data1") 'OPTIONAL - ""
        DT_Settings.Columns.Add("default_data2") 'OPTIONAL - ""
        DT_Settings.Columns.Add("default_flash") 'OPTIONAL - True/False (default - false)
        DT_Settings.Columns.Add("default_type") 'OPTIONAL - SMS / WPUSH / VCARD / PORT (default - SMS)
        DT_Settings.Columns.Add("default_costcentre") 'OPTIONAL - ""

        Dim MainDR As DataRow = DT_Settings.NewRow
        MainDR.Item("live") = "True"
        MainDR.Item("return_credits") = "True"
        MainDR.Item("return_msgs_success_count") = "True"
        MainDR.Item("return_msgs_failed_count") = "True"
        MainDR.Item("return_entries_success_status") = "True"
        MainDR.Item("return_entries_failed_status") = "True"
        MainDR.Item("default_senderid") = ""
        MainDR.Item("default_date") = Date.Now.ToString("dd/MMM/yyyy")
        MainDR.Item("default_time") = Date.Now.ToString("HH:mm")
        MainDR.Item("default_data1") = "This is a test message. If data is not specified for data1 for an entry this is selected"
        MainDR.Item("default_data2") = ""
        MainDR.Item("default_flash") = "False"
        MainDR.Item("default_type") = "SMS"
        MainDR.Item("default_costcentre") = "NA"
        DT_Settings.Rows.Add(MainDR)
        DS.Tables.Add(DT_Settings)


        ' --------------------------------- Entries --------------------------------- 
        Dim DT_Entries As New DataTable("entries")
        DT_Entries.Columns.Add(New DataColumn("numto")) 'REQUIRED
        DT_Entries.Columns.Add(New DataColumn("customerid")) 'REQUIRED
        DT_Entries.Columns.Add(New DataColumn("senderid")) 'OPTIONAL (will assume default_senderid if not present)
        DT_Entries.Columns.Add(New DataColumn("time")) 'OPTIONAL (will assume default_time if not present)
        DT_Entries.Columns.Add(New DataColumn("data1")) 'OPTIONAL (will assume default_data1 if not present)
        DT_Entries.Columns.Add(New DataColumn("data2")) 'OPTIONAL (will assume default_data2 if not present)
        DT_Entries.Columns.Add(New DataColumn("flash")) 'OPTIONAL (will assume default_flash if not present)
        DT_Entries.Columns.Add(New DataColumn("type")) 'OPTIONAL (will assume default_type if not present)
        DT_Entries.Columns.Add(New DataColumn("costcentre")) 'OPTIONAL (will assume default_costcentre if not present)

        'SMS
        Dim DR_Entry As DataRow = DT_Entries.NewRow
        DR_Entry.Item("senderid") = "Test me"
        DR_Entry.Item("numto") = txt_number.Text
        DR_Entry.Item("time") = Date.Now.ToString("HH:mm")
        DR_Entry.Item("data1") = "This is a test message 1!" 'if blank will assume default_data1 etc
        DR_Entry.Item("data2") = ""
        DR_Entry.Item("flash") = "False"
        DR_Entry.Item("type") = "SMS"
        DR_Entry.Item("customerid") = "UnqiueValue1"
        DR_Entry.Item("costcentre") = "NA"
        DT_Entries.Rows.Add(DR_Entry)

        'SMS
        Dim DR_Entry_1 As DataRow = DT_Entries.NewRow
        DR_Entry_1.Item("senderid") = "Test me"
        DR_Entry_1.Item("numto") = txt_number.Text
        DR_Entry_1.Item("time") = Date.Now.ToString("HH:mm")
        DR_Entry_1.Item("data1") = "" 'if blank will assume default_data1 etc
        DR_Entry_1.Item("data2") = ""
        DR_Entry_1.Item("flash") = "False"
        DR_Entry_1.Item("type") = "SMS"
        DR_Entry_1.Item("customerid") = "UnqiueValue1"
        DR_Entry_1.Item("costcentre") = "NA"
        DT_Entries.Rows.Add(DR_Entry_1)

        'VCARD
        Dim DR_Entry_2 As DataRow = DT_Entries.NewRow
        DR_Entry_2.Item("senderid") = "Test me"
        DR_Entry_2.Item("numto") = txt_number.Text
        DR_Entry_2.Item("time") = Date.Now.ToString("HH:mm")
        DR_Entry_2.Item("data1") = "Contact name"
        DR_Entry_2.Item("data2") = txt_number.Text 'Number you want the recipient to save on their phone.
        DR_Entry_2.Item("flash") = "False"
        DR_Entry_2.Item("type") = "VCARD"
        DR_Entry_2.Item("customerid") = Guid.NewGuid.ToString
        DR_Entry_2.Item("costcentre") = "NA"
        DT_Entries.Rows.Add(DR_Entry_2)

        'WPUSH / Will fail this message by shortening the number
        Dim DR_Entry_3 As DataRow = DT_Entries.NewRow
        DR_Entry_3.Item("senderid") = "Test me"
        DR_Entry_3.Item("numto") = txt_number.Text.Substring(4)
        DR_Entry_3.Item("time") = Date.Now.ToString("HH:mm")
        DR_Entry_3.Item("data1") = "Click here for MyMobileAPI"
        DR_Entry_3.Item("data2") = "http://www.mymobileapi.com"
        DR_Entry_3.Item("flash") = "False"
        DR_Entry_3.Item("type") = "WPUSH"
        DR_Entry_3.Item("customerid") = Guid.NewGuid.ToString
        DR_Entry_3.Item("costcentre") = "NA"
        DT_Entries.Rows.Add(DR_Entry_3)


        DS.Tables.Add(DT_Entries)

        'Sending
        txt_send_results.Text = "Input:" & vbCrLf
        txt_send_results.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_send_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_send_results.AppendText(MyAPI.Send_DS_DS(txt_username.Text, txt_password.Text, DS).GetXml)
        End Using
    End Sub

    Private Sub but_send_str_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_send_str_ds.Click
        If txt_number.Text.Equals("") Then
            MsgBox("Please enter a number")
            Exit Sub
        End If

        Dim InputString As String = ""
        InputString += "<senddata>"
        InputString += "<settings>"
        InputString += "<return_credits>True</return_credits>"
        InputString += "<return_entries_success_status>True</return_entries_success_status>"
        InputString += "<return_entries_failed_status>True</return_entries_failed_status>"
        InputString += "<default_date>" & Date.Now.ToString("dd/MMM/yyyy") & "</default_date>"
        InputString += "<default_time>" & Date.Now.ToString("HH:mm") & "</default_time>"
        InputString += "</settings>"
        InputString += "<entries>"
        '1 SMS
        InputString += "<numto>" & txt_number.Text & "</numto>"
        InputString += "<customerid>Some-GUID-or-unique-value</customerid>"
        InputString += "<data1>Hello, this is my message</data1>"

        InputString += "</entries>"
        InputString += "</senddata>"

        txt_send_results.Text = "Input:" & vbCrLf
        txt_send_results.AppendText(InputString & vbCrLf & vbCrLf)

        txt_send_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_send_results.AppendText(MyAPI.Send_STR_DS(txt_username.Text, txt_password.Text, InputString).GetXml)
        End Using
    End Sub

    Private Sub but_send_str_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_send_str_str.Click
        If txt_number.Text.Equals("") Then
            MsgBox("Please enter a number")
            Exit Sub
        End If

        Dim InputString As String = ""
        InputString += "<senddata>"
        InputString += "<settings>"
        InputString += "<return_credits>True</return_credits>"
        InputString += "<return_entries_success_status>True</return_entries_success_status>"
        InputString += "<return_entries_failed_status>True</return_entries_failed_status>"
        InputString += "<default_data1>This is a default message</default_data1>"
        InputString += "<default_date>" & Date.Now.ToString("dd/MMM/yyyy") & "</default_date>"
        InputString += "<default_time>" & Date.Now.ToString("HH:mm") & "</default_time>"
        InputString += "</settings>"
        InputString += "<entries>"
        '1 SMS
        InputString += "<numto>" & txt_number.Text & "</numto>"
        InputString += "<customerid>Some-GUID-or-unique-value</customerid>"
        InputString += "<data1>Hello, this is my message</data1>"

        InputString += "</entries>"
        InputString += "</senddata>"

        txt_send_results.Text = "Input:" & vbCrLf
        txt_send_results.AppendText(InputString & vbCrLf & vbCrLf)

        txt_send_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_send_results.AppendText(MyAPI.Send_STR_STR(txt_username.Text, txt_password.Text, InputString))
        End Using
    End Sub

    Private Sub but_send_ds_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_send_ds_str.Click
        If txt_number.Text.Equals("") Then
            MsgBox("Please enter a number")
            Exit Sub
        End If

        Dim DS As New DataSet("senddata")

        ' --------------------------------- Settings --------------------------------- 
        Dim DT_Settings As New DataTable("settings")
        DT_Settings.Columns.Add("live") 'OPTIONAL - True/False (default - true)
        DT_Settings.Columns.Add("return_credits") 'OPTIONAL - True/False
        DT_Settings.Columns.Add("return_msgs_success_count") 'OPTIONAL - True/False (default - false)
        DT_Settings.Columns.Add("return_msgs_failed_count") 'OPTIONAL - True/False (default - false)
        DT_Settings.Columns.Add("return_entries_success_status") 'OPTIONAL - True/False (default - false)
        DT_Settings.Columns.Add("return_entries_failed_status") 'OPTIONAL - True/False (default - false)
        DT_Settings.Columns.Add("default_senderid") 'OPTIONAL - 11 Char alphanumeric or 15 char numeric (default - Repliable)
        DT_Settings.Columns.Add("default_date") 'REQUIRED - dd/MMM/yyyy
        DT_Settings.Columns.Add("default_time") 'REQUIRED - HH:mm
        DT_Settings.Columns.Add("default_data1") 'OPTIONAL - ""
        DT_Settings.Columns.Add("default_data2") 'OPTIONAL - ""
        DT_Settings.Columns.Add("default_flash") 'OPTIONAL - True/False (default - false)
        DT_Settings.Columns.Add("default_type") 'OPTIONAL - SMS / WPUSH / VCARD / PORT (default - SMS)
        DT_Settings.Columns.Add("default_costcentre") 'OPTIONAL - ""

        Dim MainDR As DataRow = DT_Settings.NewRow
        MainDR.Item("live") = "True"
        MainDR.Item("return_credits") = "True"
        MainDR.Item("return_msgs_success_count") = "True"
        MainDR.Item("return_msgs_failed_count") = "True"
        MainDR.Item("return_entries_success_status") = "True"
        MainDR.Item("return_entries_failed_status") = "True"
        MainDR.Item("default_senderid") = ""
        MainDR.Item("default_date") = Date.Now.ToString("dd/MMM/yyyy")
        MainDR.Item("default_time") = Date.Now.ToString("HH:mm")
        MainDR.Item("default_data1") = "This is a test message. If data is not specified for data1 for an entry this is selected"
        MainDR.Item("default_data2") = ""
        MainDR.Item("default_flash") = "False"
        MainDR.Item("default_type") = "SMS"
        MainDR.Item("default_costcentre") = "NA"
        DT_Settings.Rows.Add(MainDR)
        DS.Tables.Add(DT_Settings)


        ' --------------------------------- Entries --------------------------------- 
        Dim DT_Entries As New DataTable("entries")
        DT_Entries.Columns.Add(New DataColumn("numto")) 'REQUIRED
        DT_Entries.Columns.Add(New DataColumn("customerid")) 'REQUIRED
        DT_Entries.Columns.Add(New DataColumn("senderid")) 'OPTIONAL (will assume default_senderid if not present)
        DT_Entries.Columns.Add(New DataColumn("time")) 'OPTIONAL (will assume default_time if not present)
        DT_Entries.Columns.Add(New DataColumn("data1")) 'OPTIONAL (will assume default_data1 if not present)
        DT_Entries.Columns.Add(New DataColumn("data2")) 'OPTIONAL (will assume default_data2 if not present)
        DT_Entries.Columns.Add(New DataColumn("flash")) 'OPTIONAL (will assume default_flash if not present)
        DT_Entries.Columns.Add(New DataColumn("type")) 'OPTIONAL (will assume default_type if not present)
        DT_Entries.Columns.Add(New DataColumn("costcentre")) 'OPTIONAL (will assume default_costcentre if not present)

        'SMS
        Dim DR_Entry As DataRow = DT_Entries.NewRow
        DR_Entry.Item("senderid") = "Test me"
        DR_Entry.Item("numto") = txt_number.Text
        DR_Entry.Item("time") = Date.Now.ToString("HH:mm")
        DR_Entry.Item("data1") = "This is a test message 1!" 'if blank will assume default_data1 etc
        DR_Entry.Item("data2") = ""
        DR_Entry.Item("flash") = "False"
        DR_Entry.Item("type") = "SMS"
        DR_Entry.Item("customerid") = "UnqiueValue1"
        DR_Entry.Item("costcentre") = "NA"
        DT_Entries.Rows.Add(DR_Entry)

        'SMS
        Dim DR_Entry_1 As DataRow = DT_Entries.NewRow
        DR_Entry_1.Item("senderid") = "Test me"
        DR_Entry_1.Item("numto") = txt_number.Text
        DR_Entry_1.Item("time") = Date.Now.ToString("HH:mm")
        DR_Entry_1.Item("data1") = "" 'if blank will assume default_data1 etc
        DR_Entry_1.Item("data2") = ""
        DR_Entry_1.Item("flash") = "False"
        DR_Entry_1.Item("type") = "SMS"
        DR_Entry_1.Item("customerid") = "UnqiueValue1"
        DR_Entry_1.Item("costcentre") = "NA"
        DT_Entries.Rows.Add(DR_Entry_1)

        'VCARD
        Dim DR_Entry_2 As DataRow = DT_Entries.NewRow
        DR_Entry_2.Item("senderid") = "Test me"
        DR_Entry_2.Item("numto") = txt_number.Text
        DR_Entry_2.Item("time") = Date.Now.ToString("HH:mm")
        DR_Entry_2.Item("data1") = "Contact name"
        DR_Entry_2.Item("data2") = txt_number.Text 'Number you want the recipient to save on their phone.
        DR_Entry_2.Item("flash") = "False"
        DR_Entry_2.Item("type") = "VCARD"
        DR_Entry_2.Item("customerid") = Guid.NewGuid.ToString
        DR_Entry_2.Item("costcentre") = "NA"
        DT_Entries.Rows.Add(DR_Entry_2)

        'WPUSH / Will fail this message by shortening the number
        Dim DR_Entry_3 As DataRow = DT_Entries.NewRow
        DR_Entry_3.Item("senderid") = "Test me"
        DR_Entry_3.Item("numto") = txt_number.Text.Substring(4)
        DR_Entry_3.Item("time") = Date.Now.ToString("HH:mm")
        DR_Entry_3.Item("data1") = "Click here for MyMobileAPI"
        DR_Entry_3.Item("data2") = "http://www.mymobileapi.com"
        DR_Entry_3.Item("flash") = "False"
        DR_Entry_3.Item("type") = "WPUSH"
        DR_Entry_3.Item("customerid") = Guid.NewGuid.ToString
        DR_Entry_3.Item("costcentre") = "NA"
        DT_Entries.Rows.Add(DR_Entry_3)


        DS.Tables.Add(DT_Entries)

        'Sending
        txt_send_results.Text = "Input:" & vbCrLf
        txt_send_results.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_send_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_send_results.AppendText(MyAPI.Send_DS_STR(txt_username.Text, txt_password.Text, DS))
        End Using
    End Sub

    Private Sub but_send_zip_zip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_send_zip_zip.Click
        'The method accepts a byte array and returns a byte array
        'The byte array is a compressed stream

        'If you want to compress a string then use - Zip(System.Text.Encoding.UTF8.GetBytes(InputString))
        'If you want to compress a Dataset called DS then use -  Zip(System.Text.Encoding.UTF8.GetBytes(DS.getXML))

        'The result can be converted to string by using  - System.Text.Encoding.UTF8.GetString(Unzip(MyAPI.Send_ZIP_ZIP(username,password,byte())))
        'The result can also be read into a Dataset by using  - DS.ReadXml(New IO.MemoryStream(Unzip(Data)))

        If txt_number.Text.Equals("") Then
            MsgBox("Please enter a number")
            Exit Sub
        End If

        Dim InputString As String = ""
        InputString += "<senddata>"
        InputString += "<settings>"
        InputString += "<return_credits>True</return_credits>"
        InputString += "<return_entries_success_status>True</return_entries_success_status>"
        InputString += "<return_entries_failed_status>True</return_entries_failed_status>"
        InputString += "<default_date>" & Date.Now.ToString("dd/MMM/yyyy") & "</default_date>"
        InputString += "<default_time>" & Date.Now.ToString("HH:mm") & "</default_time>"
        InputString += "</settings>"
        InputString += "<entries>"
        '1 SMS
        InputString += "<numto>" & txt_number.Text & "</numto>"
        InputString += "<customerid>Some-GUID-or-unique-value</customerid>"
        InputString += "<data1>Hello, this is my message</data1>"

        InputString += "</entries>"
        InputString += "</senddata>"

        txt_send_results.Text = "Input:" & vbCrLf
        txt_send_results.AppendText(InputString & vbCrLf & vbCrLf)

        txt_send_results.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_send_results.AppendText(System.Text.Encoding.UTF8.GetString(Unzip(MyAPI.Send_ZIP_ZIP(txt_username.Text, txt_password.Text, Zip(System.Text.Encoding.UTF8.GetBytes(InputString))))))
        End Using
    End Sub
#End Region

#Region " Credits check "
    Private Sub but_credits_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_credits_str.Click
        txt_credits_result.Text = ""

        Using MyAPI As New MyAPI_Fix
            txt_credits_result.AppendText(MyAPI.Credits_STR(txt_username.Text, txt_password.Text))
        End Using
    End Sub

    Private Sub but_credits_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_credits_ds.Click
        txt_credits_result.Text = ""

        Using MyAPI As New MyAPI_Fix
            txt_credits_result.AppendText(MyAPI.Credits_DS(txt_username.Text, txt_password.Text).GetXml)
        End Using
    End Sub
#End Region

#Region " Shortcodes "
    Private Sub but_shortcode_str_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_str_str.Click
        Dim InputString As String = ""
        InputString += "<options>"
        InputString += "<settings>"
        InputString += "<cols_returned>shortcode,enddate,posturl</cols_returned>" 'OPTIONAL. Seperte col name with comma, this allows you to strip the returned data (default = id)
        InputString += "<date_format>dd/MMM/yyyy</date_format>" '(optional) dd = day. MM = month. MMM = monthname (feb). yyyy = year. HH = hour. mm = minute. ss = second
        InputString += "</settings>"
        InputString += "</options>"

        txt_shortcode_result.Text = "Input:" & vbCrLf
        txt_shortcode_result.AppendText(InputString & vbCrLf & vbCrLf)

        txt_shortcode_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_result.AppendText(MyAPI.ShortCode_STR_STR(txt_username.Text, txt_password.Text, InputString))
        End Using
    End Sub

    Private Sub but_shortcode_str_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_str_ds.Click
        Dim InputString As String = ""
        InputString += "<options>"
        InputString += "<settings>"
        InputString += "<cols_returned>shortcode,enddate,posturl</cols_returned>" 'OPTIONAL. Seperte col name with comma, this allows you to strip the returned data (default = id)
        InputString += "<date_format>dd/MMM/yyyy</date_format>" '(optional) dd = day. MM = month. MMM = monthname (feb). yyyy = year. HH = hour. mm = minute. ss = second
        InputString += "</settings>"
        InputString += "</options>"

        txt_shortcode_result.Text = "Input:" & vbCrLf
        txt_shortcode_result.AppendText(InputString & vbCrLf & vbCrLf)

        txt_shortcode_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_result.AppendText(MyAPI.ShortCode_STR_DS(txt_username.Text, txt_password.Text, InputString).GetXml)
        End Using
    End Sub

    Private Sub but_shortcode_ds_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_ds_ds.Click
        Dim DS As New DataSet("options")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("cols_returned") 'OPTIONAL. Seperte col name with comma, this allows you to strip the returned data (default = id)
        DT.Columns.Add("date_format") 'OPTIONAL. (default = dd/MMM/yyyy HH:mm:ss)

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("cols_returned") = "shortcode,enddate,posturl" 'shortcode,keyword, startdate, enddate, posturl, forwardemail, forwardmobile, response, campaign, reportday, reportweek, reportmonth
        MainDR.Item("date_format") = "yyyyMMddHHmmss" 'default = dd/MMM/yyyy HH:mm:ss
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_shortcode_result.Text = "Input:" & vbCrLf
        txt_shortcode_result.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_shortcode_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_result.AppendText(MyAPI.ShortCode_DS_DS(txt_username.Text, txt_password.Text, DS).GetXml)
        End Using
    End Sub

    Private Sub but_shortcode_ds_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_ds_str.Click
        Dim DS As New DataSet("options")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("cols_returned") 'OPTIONAL. Seperte col name with comma, this allows you to strip the returned data (default = id)
        DT.Columns.Add("date_format") 'OPTIONAL. (default = dd/MMM/yyyy HH:mm:ss)

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("cols_returned") = "shortcode,enddate,posturl" 'shortcode,keyword, startdate, enddate, posturl, forwardemail, forwardmobile, response, campaign, reportday, reportweek, reportmonth
        MainDR.Item("date_format") = "yyyyMMddHHmmss" 'default = dd/MMM/yyyy HH:mm:ss
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_shortcode_result.Text = "Input:" & vbCrLf
        txt_shortcode_result.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_shortcode_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_result.AppendText(MyAPI.ShortCode_DS_STR(txt_username.Text, txt_password.Text, DS))
        End Using
    End Sub
#End Region

#Region " Shortcodes Update "
    Private Sub but_shortcode_update_str_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_update_str_str.Click
        If txt_shortcode_update_id.Text.Equals("") Then
            MsgBox("Please enter a value into the ID field")
            Exit Sub
        End If

        Dim InputString As String = ""
        InputString += "<options>"
        InputString += "<settings>"
        InputString += "<id>" & txt_shortcode_update_id.Text & "</id>" 'OPTIONAL. Seperte col name with comma, this allows you to strip the returned data (default = id)
        InputString += "<posturl>http://www.mydomain.co.za/mypage.asp?ID=@@ID@@&SC=@@SC@@</posturl>" '(optional)
        InputString += "<forwardemail>email@mydomain.co.za,info@gmail.com</posturl>" '(optional)
        InputString += "</settings>"
        InputString += "</options>"

        txt_shortcode_update_result.Text = "Input:" & vbCrLf
        txt_shortcode_update_result.AppendText(InputString & vbCrLf & vbCrLf)

        txt_shortcode_update_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_update_result.AppendText(MyAPI.ShortCode_Update_STR_STR(txt_username.Text, txt_password.Text, InputString))
        End Using
    End Sub

    Private Sub but_shortcode_update_str_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_update_str_ds.Click
        If txt_shortcode_update_id.Text.Equals("") Then
            MsgBox("Please enter a value into the ID field")
            Exit Sub
        End If

        Dim InputString As String = ""
        InputString += "<options>"
        InputString += "<settings>"
        InputString += "<id>" & txt_shortcode_update_id.Text & "</id>" 'OPTIONAL. Seperte col name with comma, this allows you to strip the returned data (default = id)
        InputString += "<posturl>http://www.mydomain.co.za/mypage.asp?ID=@@ID@@&SC=@@SC@@</posturl>" '(optional)
        InputString += "<forwardemail>email@mydomain.co.za,info@gmail.com</posturl>" '(optional)
        InputString += "</settings>"
        InputString += "</options>"

        txt_shortcode_update_result.Text = "Input:" & vbCrLf
        txt_shortcode_update_result.AppendText(InputString & vbCrLf & vbCrLf)

        txt_shortcode_update_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_update_result.AppendText(MyAPI.ShortCode_Update_STR_DS(txt_username.Text, txt_password.Text, InputString).GetXml)
        End Using
    End Sub

    Private Sub but_shortcode_update_ds_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_update_ds_str.Click
        If txt_shortcode_update_id.Text.Equals("") Then
            MsgBox("Please enter a value into the ID field")
            Exit Sub
        End If

        Dim DS As New DataSet("options")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("id") 'REQUIRED. The ID of the shortcode you wish to edit
        DT.Columns.Add("posturl") 'OPTIONAL. (default = "")
        DT.Columns.Add("forwardemail") 'OPTIONAL. Emails seperated with a comma. (default = "")
        DT.Columns.Add("forwardmobile") 'OPTIONAL. (default = "")
        DT.Columns.Add("response") 'OPTIONAL. (default = "")
        DT.Columns.Add("campaign") 'OPTIONAL. (default = "")
        DT.Columns.Add("reportday") 'OPTIONAL. (default = "")
        DT.Columns.Add("reportweek") 'OPTIONAL. (default = "")
        DT.Columns.Add("reportmonth") 'OPTIONAL. (default = "")

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("id") = txt_shortcode_update_id.Text
        MainDR.Item("posturl") = "" 'fully qualified URL. EG: http://www.mydomain.com/shortcode.php?ID=@@ID@@&Msg=@@MSG@@ etc. Placeholders can be : @@ID@@, @@Message@@, @@SC@@, @@Keyword@@, @@Mobile@@
        MainDR.Item("forwardemail") = ""
        MainDR.Item("forwardmobile") = ""
        MainDR.Item("response") = ""
        MainDR.Item("campaign") = "Win a TV!"
        MainDR.Item("reportday") = ""
        MainDR.Item("reportweek") = ""
        MainDR.Item("reportmonth") = ""
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_shortcode_update_result.Text = "Input:" & vbCrLf
        txt_shortcode_update_result.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_shortcode_update_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_update_result.AppendText(MyAPI.ShortCode_Update_DS_STR(txt_username.Text, txt_password.Text, DS))
        End Using
    End Sub

    Private Sub but_shortcode_update_ds_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_update_ds_ds.Click
        If txt_shortcode_update_id.Text.Equals("") Then
            MsgBox("Please enter a value into the ID field")
            Exit Sub
        End If

        Dim DS As New DataSet("options")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("id") 'REQUIRED. The ID of the shortcode you wish to edit
        DT.Columns.Add("posturl") 'OPTIONAL. (default = "")
        DT.Columns.Add("forwardemail") 'OPTIONAL. Emails seperated with a comma. (default = "")
        DT.Columns.Add("forwardmobile") 'OPTIONAL. (default = "")
        DT.Columns.Add("response") 'OPTIONAL. (default = "")
        DT.Columns.Add("campaign") 'OPTIONAL. (default = "")
        DT.Columns.Add("reportday") 'OPTIONAL. (default = "")
        DT.Columns.Add("reportweek") 'OPTIONAL. (default = "")
        DT.Columns.Add("reportmonth") 'OPTIONAL. (default = "")

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("id") = txt_shortcode_update_id.Text
        MainDR.Item("posturl") = "" 'fully qualified URL. EG: http://www.mydomain.com/shortcode.php?ID=@@ID@@&Msg=@@MSG@@ etc. Placeholders can be : @@ID@@, @@Message@@, @@SC@@, @@Keyword@@, @@Mobile@@
        MainDR.Item("forwardemail") = ""
        MainDR.Item("forwardmobile") = ""
        MainDR.Item("response") = ""
        MainDR.Item("campaign") = "Win a TV!"
        MainDR.Item("reportday") = ""
        MainDR.Item("reportweek") = ""
        MainDR.Item("reportmonth") = ""
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_shortcode_update_result.Text = "Input:" & vbCrLf
        txt_shortcode_update_result.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_shortcode_update_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_update_result.AppendText(MyAPI.ShortCode_Update_DS_DS(txt_username.Text, txt_password.Text, DS).GetXml)
        End Using
    End Sub
#End Region

#Region " Shortcodes GET "
    Private Sub but_shortcode_get_ds_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_get_ds_ds.Click
        Dim DS As New DataSet("options")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("id") 'REQUIRED. Maximum ID from previous call
        DT.Columns.Add("date_format") 'OPTIONAL. (default = dd/MMM/yyyy HH:mm:ss)

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("id") = "0"
        MainDR.Item("date_format") = "yyyyMMddHHmmss"
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_shortcode_get_result.Text = "Input:" & vbCrLf
        txt_shortcode_get_result.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_shortcode_get_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_get_result.AppendText(MyAPI.ShortCode_Get_DS_DS(txt_username.Text, txt_password.Text, DS).GetXml)
        End Using
    End Sub

    Private Sub but_shortcode_get_str_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_get_str_str.Click
        Dim InputString As String = ""
        InputString += "<options>"
        InputString += "<settings>"
        InputString += "<id>0</id>" '(required)
        InputString += "<date_format>dd/MMM/yyyy</date_format>" '(optional) dd = day. MM = month. MMM = monthname (feb). yyyy = year. HH = hour. mm = minute. ss = second
        InputString += "</settings>"
        InputString += "</options>"

        txt_shortcode_get_result.Text = "Input:" & vbCrLf
        txt_shortcode_get_result.AppendText(InputString & vbCrLf & vbCrLf)

        txt_shortcode_get_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_get_result.AppendText(MyAPI.ShortCode_Get_STR_STR(txt_username.Text, txt_password.Text, InputString))
        End Using
    End Sub

    Private Sub but_shortcode_get_str_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_get_str_ds.Click
        Dim InputString As String = ""
        InputString += "<options>"
        InputString += "<settings>"
        InputString += "<id>0</id>" '(required)
        InputString += "<date_format>dd/MMM/yyyy</date_format>" '(optional) dd = day. MM = month. MMM = monthname (feb). yyyy = year. HH = hour. mm = minute. ss = second
        InputString += "</settings>"
        InputString += "</options>"

        txt_shortcode_get_result.Text = "Input:" & vbCrLf
        txt_shortcode_get_result.AppendText(InputString & vbCrLf & vbCrLf)

        txt_shortcode_get_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_get_result.AppendText(MyAPI.ShortCode_Get_STR_DS(txt_username.Text, txt_password.Text, InputString).GetXml)
        End Using
    End Sub

    Private Sub but_shortcode_get_ds_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_shortcode_get_ds_str.Click
        Dim DS As New DataSet("options")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("id") 'REQUIRED. Maximum ID from previous call
        DT.Columns.Add("date_format") 'OPTIONAL. (default = dd/MMM/yyyy HH:mm:ss)

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("id") = "0"
        MainDR.Item("date_format") = "yyyyMMddHHmmss"
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_shortcode_get_result.Text = "Input:" & vbCrLf
        txt_shortcode_get_result.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_shortcode_get_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_shortcode_get_result.AppendText(MyAPI.ShortCode_Get_DS_STR(txt_username.Text, txt_password.Text, DS))
        End Using
    End Sub

#End Region

#Region " Groups List "
    Private Sub but_groups_list_str_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_groups_list_str_str.Click
        Dim InputString As String = ""
        InputString += "<options>"
        InputString += "<settings>"
        InputString += "<cols_returned>groupname,groupdesc,groupcreated</cols_returned>" 'REQUIRED. Seperte col name with comma, this allows you to strip the returned data (default = groupid)
        InputString += "<date_format>dd/MMM/yyyy</date_format>" '(optional) dd = day. MM = month. MMM = monthname (feb). yyyy = year. HH = hour. mm = minute. ss = second
        InputString += "</settings>"
        InputString += "</options>"

        txt_groups_list_result.Text = "Input:" & vbCrLf
        txt_groups_list_result.AppendText(InputString & vbCrLf & vbCrLf)

        txt_groups_list_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_groups_list_result.AppendText(MyAPI.Groups_List_STR_STR(txt_username.Text, txt_password.Text, InputString))
        End Using
    End Sub

    Private Sub but_groups_list_str_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_groups_list_str_ds.Click
        Dim InputString As String = ""
        InputString += "<options>"
        InputString += "<settings>"
        InputString += "<cols_returned>groupname,groupdesc,groupcreated</cols_returned>" 'REQUIRED. Seperte col name with comma, this allows you to strip the returned data (default = groupid)
        InputString += "<date_format>dd/MMM/yyyy</date_format>" '(optional) dd = day. MM = month. MMM = monthname (feb). yyyy = year. HH = hour. mm = minute. ss = second
        InputString += "</settings>"
        InputString += "</options>"

        txt_groups_list_result.Text = "Input:" & vbCrLf
        txt_groups_list_result.AppendText(InputString & vbCrLf & vbCrLf)

        txt_groups_list_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_groups_list_result.AppendText(MyAPI.Groups_List_STR_DS(txt_username.Text, txt_password.Text, InputString).GetXml)
        End Using
    End Sub

    Private Sub but_groups_list_ds_ds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_groups_list_ds_ds.Click
        Dim DS As New DataSet("options")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("cols_returned") 'REQUIRED. Seperte col name with comma, this allows you to strip the returned data (default = groupid)
        DT.Columns.Add("date_format") 'OPTIONAL. (default = dd/MMM/yyyy HH:mm:ss)

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("cols_returned") = "groupname,groupdesc,groupcreated" 'shortcode,keyword, startdate, enddate, posturl, forwardemail, forwardmobile, response, campaign, reportday, reportweek, reportmonth
        MainDR.Item("date_format") = "yyyyMMddHHmmss" 'default = dd/MMM/yyyy HH:mm:ss
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_groups_list_result.Text = "Input:" & vbCrLf
        txt_groups_list_result.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_groups_list_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_groups_list_result.AppendText(MyAPI.Groups_List_DS_DS(txt_username.Text, txt_password.Text, DS).GetXml)
        End Using
    End Sub

    Private Sub but_groups_list_ds_str_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles but_groups_list_ds_str.Click
        Dim DS As New DataSet("options")
        Dim DT As New DataTable("settings")
        DT.Columns.Add("cols_returned") 'REQUIRED. Seperte col name with comma, this allows you to strip the returned data (default = groupid)
        DT.Columns.Add("date_format") 'OPTIONAL. (default = dd/MMM/yyyy HH:mm:ss)

        Dim MainDR As DataRow = DT.NewRow
        MainDR.Item("cols_returned") = "groupname,groupdesc,groupcreated" 'shortcode,keyword, startdate, enddate, posturl, forwardemail, forwardmobile, response, campaign, reportday, reportweek, reportmonth
        MainDR.Item("date_format") = "yyyyMMddHHmmss" 'default = dd/MMM/yyyy HH:mm:ss
        DT.Rows.Add(MainDR)

        DS.Tables.Add(DT)

        txt_groups_list_result.Text = "Input:" & vbCrLf
        txt_groups_list_result.AppendText(DS.GetXml & vbCrLf & vbCrLf)

        txt_groups_list_result.AppendText("Output:" & vbCrLf)

        Using MyAPI As New MyAPI_Fix
            txt_groups_list_result.AppendText(MyAPI.Groups_List_DS_STR(txt_username.Text, txt_password.Text, DS))
        End Using
    End Sub
#End Region

    Public Function Zip(ByVal byteSource() As Byte) As Byte()
        Dim objMemStream As New IO.MemoryStream()

        Using objGZipStream As New GZipStream(objMemStream, CompressionMode.Compress, True)
            objGZipStream.Write(byteSource, 0, byteSource.Length)
        End Using

        objMemStream.Position = 0

        ' Write compressed memory stream into byte array
        Dim buffer(objMemStream.Length) As Byte
        objMemStream.Read(buffer, 0, buffer.Length)
        objMemStream.Dispose()

        Return buffer
    End Function

    Public Function Unzip(ByVal CompressedByte() As Byte) As Byte()
        Try
            Dim objMemStream As New IO.MemoryStream(CompressedByte)
            Dim objGZipStream As New GZipStream(objMemStream, CompressionMode.Decompress)

            Dim sizeBytes(3) As Byte
            objMemStream.Position = objMemStream.Length - 5
            objMemStream.Read(sizeBytes, 0, 4)

            Dim iOutputSize As Integer = BitConverter.ToInt32(sizeBytes, 0)

            objMemStream.Position = 0

            Dim decompressedBytes(iOutputSize - 1) As Byte

            objGZipStream.Read(decompressedBytes, 0, iOutputSize)

            objGZipStream.Dispose()
            objMemStream.Dispose()

            Return decompressedBytes
        Catch ex As Exception
            Return Nothing
        End Try
    End Function

End Class

